/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package modelo;

import java.io.Serializable;
import java.math.BigDecimal;
import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;

/**
 *
 * @author willian
 */
@Entity
@Table(name = "Compoe")
@NamedQueries({
    @NamedQuery(name = "Compoe.findAll", query = "SELECT c FROM Compoe c"),
    @NamedQuery(name = "Compoe.findByProdutoId", query = "SELECT c FROM Compoe c WHERE c.compoePK.produtoId = :produtoId"),
    @NamedQuery(name = "Compoe.findByProdutoParte", query = "SELECT c FROM Compoe c WHERE c.compoePK.produtoParte = :produtoParte"),
    @NamedQuery(name = "Compoe.findByQuantidade", query = "SELECT c FROM Compoe c WHERE c.quantidade = :quantidade")})
public class Compoe implements Serializable {
    private static final long serialVersionUID = 1L;
    @EmbeddedId
    protected CompoePK compoePK;
    @Basic(optional = false)
    @Column(name = "quantidade")
    private BigDecimal quantidade;
    @JoinColumn(name = "produto_parte", referencedColumnName = "id", insertable = false, updatable = false)
    @ManyToOne(optional = false)
    private Produto parte;
    @JoinColumn(name = "produto_id", referencedColumnName = "id", insertable = false, updatable = false)
    @ManyToOne(optional = false)
    private Produto produto;

    public Compoe() {
    }

    public Compoe(CompoePK compoePK) {
        this.compoePK = compoePK;
    }

    public Compoe(CompoePK compoePK, BigDecimal quantidade) {
        this.compoePK = compoePK;
        this.quantidade = quantidade;
    }

    public Compoe(int produtoId, int produtoParte) {
        this.compoePK = new CompoePK(produtoId, produtoParte);
    }

    public CompoePK getCompoePK() {
        return compoePK;
    }

    public void setCompoePK(CompoePK compoePK) {
        this.compoePK = compoePK;
    }

    public BigDecimal getQuantidade() {
        return quantidade;
    }

    public void setQuantidade(BigDecimal quantidade) {
        this.quantidade = quantidade;
    }

    public Produto getParte() {
        return parte;
    }

    public void setParte(Produto produto) {
        this.parte = produto;
    }

    public Produto getProduto() {
        return produto;
    }

    public void setProduto(Produto produto1) {
        this.produto = produto1;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (compoePK != null ? compoePK.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Compoe)) {
            return false;
        }
        Compoe other = (Compoe) object;
        if ((this.compoePK == null && other.compoePK != null) || (this.compoePK != null && !this.compoePK.equals(other.compoePK))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "modelo.Compoe[compoePK=" + compoePK + "]";
    }

}
