/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package modelo;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Collection;
import javax.persistence.Basic;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.OneToMany;
import javax.persistence.Table;

/**
 *
 * @author willian
 */
@Entity
@Table(name = "Produto")
@NamedQueries({
    @NamedQuery(name = "Produto.findAll", query = "SELECT p FROM Produto p"),
    @NamedQuery(name = "Produto.findById", query = "SELECT p FROM Produto p WHERE p.id = :id"),
    @NamedQuery(name = "Produto.findByCusto", query = "SELECT p FROM Produto p WHERE p.custo = :custo"),
    @NamedQuery(name = "Produto.findByPreco", query = "SELECT p FROM Produto p WHERE p.preco = :preco"),
    @NamedQuery(name = "Produto.findByEstoque", query = "SELECT p FROM Produto p WHERE p.estoque = :estoque"),
    @NamedQuery(name = "Produto.findByClasse", query = "SELECT p FROM Produto p WHERE p.classe = :classe")})
public class Produto implements Serializable {
    private static final long serialVersionUID = 1L;
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Basic(optional = false)
    @Column(name = "id")
    private Integer id;

    @Column(name = "nome")
    private String nome;

    @Column(name="codigo")
    private String codigo;

    @Column(name = "custo")
    private BigDecimal custo;

    @Column(name = "preco")
    private BigDecimal preco;

    @Column(name = "estoque")
    private Integer estoque;

    @Basic(optional = false)
    @Column(name = "classe")
    private int classe;

    @OneToMany(cascade = CascadeType.ALL, mappedBy = "produto")
    private Collection<PedidoProducao> pedidoProducaoCollection;

    @OneToMany(cascade = CascadeType.ALL, mappedBy = "produto")
    private Collection<Venda> vendaCollection;

    @OneToMany(cascade = CascadeType.ALL, mappedBy = "produto")
    private Collection<Fornece> forneceCollection;

    @OneToMany(cascade = CascadeType.ALL, mappedBy = "produto")
    private Collection<Compra> compraCollection;

    @OneToMany(mappedBy = "parte")
    private Collection<Compoe> compoeCollection;
        @OneToMany(mappedBy = "produto")
    private Collection<Compoe> compoeCollection1;

    public Produto() {
    }

    public Produto(Integer id) {
        this.id = id;
    }

    public Produto(Integer id, int classe) {
        this.id = id;
        this.classe = classe;
    }

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public BigDecimal getCusto() {
        return custo;
    }

    public void setCusto(BigDecimal custo) {
        this.custo = custo;
    }

    public BigDecimal getPreco() {
        return preco;
    }

    public void setPreco(BigDecimal preco) {
        this.preco = preco;
    }

    public Integer getEstoque() {
        return estoque;
    }

    public void setEstoque(Integer estoque) {
        this.estoque = estoque;
    }

    public int getClasse() {
        return classe;
    }

    public void setClasse(int classe) {
        this.classe = classe;
    }

    public String getNome() {
        return nome;
    }

    public void setNome(String nome) {
        this.nome = nome;
    }

    public String getCodigo() {
        return codigo;
    }

    public void setCodigo(String codigo) {
        this.codigo = codigo;
    }

    public Collection<PedidoProducao> getPedidoProducaoCollection() {
        return pedidoProducaoCollection;
    }

    public void setPedidoProducaoCollection(Collection<PedidoProducao> pedidoProducaoCollection) {
        this.pedidoProducaoCollection = pedidoProducaoCollection;
    }

    public Collection<Venda> getVendaCollection() {
        return vendaCollection;
    }

    public void setVendaCollection(Collection<Venda> vendaCollection) {
        this.vendaCollection = vendaCollection;
    }

    public Collection<Fornece> getForneceCollection() {
        return forneceCollection;
    }

    public void setForneceCollection(Collection<Fornece> forneceCollection) {
        this.forneceCollection = forneceCollection;
    }

    public Collection<Compra> getCompraCollection() {
        return compraCollection;
    }

    public void setCompraCollection(Collection<Compra> compraCollection) {
        this.compraCollection = compraCollection;
    }

    public Collection<Compoe> getCompoeCollection() {
        return compoeCollection;
    }

    public void setCompoeCollection(Collection<Compoe> compoeCollection) {
        this.compoeCollection = compoeCollection;
    }

    public Collection<Compoe> getCompoeCollection1() {
        return compoeCollection1;
    }

    public void setCompoeCollection1(Collection<Compoe> compoeCollection1) {
        this.compoeCollection1 = compoeCollection1;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (id != null ? id.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Produto)) {
            return false;
        }
        Produto other = (Produto) object;
        if ((this.id == null && other.id != null) || (this.id != null && !this.id.equals(other.id))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "modelo.Produto[id=" + id + "]";
    }

}
