/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package modelo.controle;

import java.util.List;
import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;
import javax.persistence.Query;
import javax.persistence.EntityNotFoundException;
import modelo.Compoe;
import modelo.CompoePK;
import modelo.Produto;
import modelo.controle.exceptions.NonexistentEntityException;
import modelo.controle.exceptions.PreexistingEntityException;

/**
 *
 * @author willian
 */
public class CompoeJpaController {

    public CompoeJpaController() {
        emf = Persistence.createEntityManagerFactory("EstoquePU");
    }
    private EntityManagerFactory emf = null;

    public EntityManager getEntityManager() {
        return emf.createEntityManager();
    }

    public void create(Compoe compoe) throws PreexistingEntityException, Exception {
        if (compoe.getCompoePK() == null) {
            compoe.setCompoePK(new CompoePK());
        }
        compoe.getCompoePK().setProdutoId(compoe.getProduto().getId());
        compoe.getCompoePK().setProdutoParte(compoe.getParte().getId());
        EntityManager em = null;
        try {
            em = getEntityManager();
            em.getTransaction().begin();
            Produto produto = compoe.getParte();
            if (produto != null) {
                produto = em.getReference(produto.getClass(), produto.getId());
                compoe.setParte(produto);
            }
            Produto produto1 = compoe.getProduto();
            if (produto1 != null) {
                produto1 = em.getReference(produto1.getClass(), produto1.getId());
                compoe.setProduto(produto1);
            }
            em.persist(compoe);
            if (produto != null) {
                produto.getCompoeCollection().add(compoe);
                produto = em.merge(produto);
            }
            if (produto1 != null) {
                produto1.getCompoeCollection().add(compoe);
                produto1 = em.merge(produto1);
            }
            em.getTransaction().commit();
        } catch (Exception ex) {
            if (findCompoe(compoe.getCompoePK()) != null) {
                throw new PreexistingEntityException("Compoe " + compoe + " already exists.", ex);
            }
            throw ex;
        } finally {
            if (em != null) {
                em.close();
            }
        }
    }

    public void edit(Compoe compoe) throws NonexistentEntityException, Exception {
        compoe.getCompoePK().setProdutoId(compoe.getProduto().getId());
        compoe.getCompoePK().setProdutoParte(compoe.getParte().getId());
        EntityManager em = null;
        try {
            em = getEntityManager();
            em.getTransaction().begin();
            Compoe persistentCompoe = em.find(Compoe.class, compoe.getCompoePK());
            Produto produtoOld = persistentCompoe.getParte();
            Produto produtoNew = compoe.getParte();
            Produto produto1Old = persistentCompoe.getProduto();
            Produto produto1New = compoe.getProduto();
            if (produtoNew != null) {
                produtoNew = em.getReference(produtoNew.getClass(), produtoNew.getId());
                compoe.setParte(produtoNew);
            }
            if (produto1New != null) {
                produto1New = em.getReference(produto1New.getClass(), produto1New.getId());
                compoe.setProduto(produto1New);
            }
            compoe = em.merge(compoe);
            if (produtoOld != null && !produtoOld.equals(produtoNew)) {
                produtoOld.getCompoeCollection().remove(compoe);
                produtoOld = em.merge(produtoOld);
            }
            if (produtoNew != null && !produtoNew.equals(produtoOld)) {
                produtoNew.getCompoeCollection().add(compoe);
                produtoNew = em.merge(produtoNew);
            }
            if (produto1Old != null && !produto1Old.equals(produto1New)) {
                produto1Old.getCompoeCollection().remove(compoe);
                produto1Old = em.merge(produto1Old);
            }
            if (produto1New != null && !produto1New.equals(produto1Old)) {
                produto1New.getCompoeCollection().add(compoe);
                produto1New = em.merge(produto1New);
            }
            em.getTransaction().commit();
        } catch (Exception ex) {
            String msg = ex.getLocalizedMessage();
            if (msg == null || msg.length() == 0) {
                CompoePK id = compoe.getCompoePK();
                if (findCompoe(id) == null) {
                    throw new NonexistentEntityException("The compoe with id " + id + " no longer exists.");
                }
            }
            throw ex;
        } finally {
            if (em != null) {
                em.close();
            }
        }
    }

    public void destroy(CompoePK id) throws NonexistentEntityException {
        EntityManager em = null;
        try {
            em = getEntityManager();
            em.getTransaction().begin();
            Compoe compoe;
            try {
                compoe = em.getReference(Compoe.class, id);
                compoe.getCompoePK();
            } catch (EntityNotFoundException enfe) {
                throw new NonexistentEntityException("The compoe with id " + id + " no longer exists.", enfe);
            }
            Produto produto = compoe.getParte();
            if (produto != null) {
                produto.getCompoeCollection().remove(compoe);
                produto = em.merge(produto);
            }
            Produto produto1 = compoe.getProduto();
            if (produto1 != null) {
                produto1.getCompoeCollection().remove(compoe);
                produto1 = em.merge(produto1);
            }
            em.remove(compoe);
            em.getTransaction().commit();
        } finally {
            if (em != null) {
                em.close();
            }
        }
    }

    public List<Compoe> findCompoeEntities() {
        return findCompoeEntities(true, -1, -1);
    }

    public List<Compoe> findCompoeEntities(int maxResults, int firstResult) {
        return findCompoeEntities(false, maxResults, firstResult);
    }

    private List<Compoe> findCompoeEntities(boolean all, int maxResults, int firstResult) {
        EntityManager em = getEntityManager();
        try {
            Query q = em.createQuery("select object(o) from Compoe as o");
            if (!all) {
                q.setMaxResults(maxResults);
                q.setFirstResult(firstResult);
            }
            return q.getResultList();
        } finally {
            em.close();
        }
    }

    public Compoe findCompoe(CompoePK id) {
        EntityManager em = getEntityManager();
        try {
            return em.find(Compoe.class, id);
        } finally {
            em.close();
        }
    }

    public int getCompoeCount() {
        EntityManager em = getEntityManager();
        try {
            Query q = em.createQuery("select count(o) from Compoe as o");
            return ((Long) q.getSingleResult()).intValue();
        } finally {
            em.close();
        }
    }

}
