/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package modelo.controle;

import java.util.List;
import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;
import javax.persistence.Query;
import javax.persistence.EntityNotFoundException;
import modelo.Funcionario;
import modelo.PedidoCompra;
import java.util.ArrayList;
import java.util.Collection;
import modelo.PedidoProducao;
import modelo.Cliente;
import modelo.PedidoVenda;
import modelo.controle.exceptions.IllegalOrphanException;
import modelo.controle.exceptions.NonexistentEntityException;
import modelo.controle.exceptions.PreexistingEntityException;

/**
 *
 * @author willian
 */
public class FuncionarioJpaController {

    public FuncionarioJpaController() {
        emf = Persistence.createEntityManagerFactory("EstoquePU");
    }
    private EntityManagerFactory emf = null;

    public EntityManager getEntityManager() {
        return emf.createEntityManager();
    }

    public void create(Funcionario funcionario) throws PreexistingEntityException, Exception {
        if (funcionario.getPedidoCompraCollection() == null) {
            funcionario.setPedidoCompraCollection(new ArrayList<PedidoCompra>());
        }
        if (funcionario.getPedidoProducaoCollection() == null) {
            funcionario.setPedidoProducaoCollection(new ArrayList<PedidoProducao>());
        }
        if (funcionario.getClienteCollection() == null) {
            funcionario.setClienteCollection(new ArrayList<Cliente>());
        }
        if (funcionario.getPedidoVendaCollection() == null) {
            funcionario.setPedidoVendaCollection(new ArrayList<PedidoVenda>());
        }
        EntityManager em = null;
        try {
            em = getEntityManager();
            em.getTransaction().begin();
            Collection<PedidoCompra> attachedPedidoCompraCollection = new ArrayList<PedidoCompra>();
            for (PedidoCompra pedidoCompraCollectionPedidoCompraToAttach : funcionario.getPedidoCompraCollection()) {
                pedidoCompraCollectionPedidoCompraToAttach = em.getReference(pedidoCompraCollectionPedidoCompraToAttach.getClass(), pedidoCompraCollectionPedidoCompraToAttach.getId());
                attachedPedidoCompraCollection.add(pedidoCompraCollectionPedidoCompraToAttach);
            }
            funcionario.setPedidoCompraCollection(attachedPedidoCompraCollection);
            Collection<PedidoProducao> attachedPedidoProducaoCollection = new ArrayList<PedidoProducao>();
            for (PedidoProducao pedidoProducaoCollectionPedidoProducaoToAttach : funcionario.getPedidoProducaoCollection()) {
                pedidoProducaoCollectionPedidoProducaoToAttach = em.getReference(pedidoProducaoCollectionPedidoProducaoToAttach.getClass(), pedidoProducaoCollectionPedidoProducaoToAttach.getId());
                attachedPedidoProducaoCollection.add(pedidoProducaoCollectionPedidoProducaoToAttach);
            }
            funcionario.setPedidoProducaoCollection(attachedPedidoProducaoCollection);
            Collection<Cliente> attachedClienteCollection = new ArrayList<Cliente>();
            for (Cliente clienteCollectionClienteToAttach : funcionario.getClienteCollection()) {
                clienteCollectionClienteToAttach = em.getReference(clienteCollectionClienteToAttach.getClass(), clienteCollectionClienteToAttach.getId());
                attachedClienteCollection.add(clienteCollectionClienteToAttach);
            }
            funcionario.setClienteCollection(attachedClienteCollection);
            Collection<PedidoVenda> attachedPedidoVendaCollection = new ArrayList<PedidoVenda>();
            for (PedidoVenda pedidoVendaCollectionPedidoVendaToAttach : funcionario.getPedidoVendaCollection()) {
                pedidoVendaCollectionPedidoVendaToAttach = em.getReference(pedidoVendaCollectionPedidoVendaToAttach.getClass(), pedidoVendaCollectionPedidoVendaToAttach.getId());
                attachedPedidoVendaCollection.add(pedidoVendaCollectionPedidoVendaToAttach);
            }
            funcionario.setPedidoVendaCollection(attachedPedidoVendaCollection);
            em.persist(funcionario);
            for (PedidoCompra pedidoCompraCollectionPedidoCompra : funcionario.getPedidoCompraCollection()) {
                Funcionario oldFuncionarioOfPedidoCompraCollectionPedidoCompra = pedidoCompraCollectionPedidoCompra.getFuncionario();
                pedidoCompraCollectionPedidoCompra.setFuncionario(funcionario);
                pedidoCompraCollectionPedidoCompra = em.merge(pedidoCompraCollectionPedidoCompra);
                if (oldFuncionarioOfPedidoCompraCollectionPedidoCompra != null) {
                    oldFuncionarioOfPedidoCompraCollectionPedidoCompra.getPedidoCompraCollection().remove(pedidoCompraCollectionPedidoCompra);
                    oldFuncionarioOfPedidoCompraCollectionPedidoCompra = em.merge(oldFuncionarioOfPedidoCompraCollectionPedidoCompra);
                }
            }
            for (PedidoProducao pedidoProducaoCollectionPedidoProducao : funcionario.getPedidoProducaoCollection()) {
                Funcionario oldFuncionarioOfPedidoProducaoCollectionPedidoProducao = pedidoProducaoCollectionPedidoProducao.getFuncionario();
                pedidoProducaoCollectionPedidoProducao.setFuncionario(funcionario);
                pedidoProducaoCollectionPedidoProducao = em.merge(pedidoProducaoCollectionPedidoProducao);
                if (oldFuncionarioOfPedidoProducaoCollectionPedidoProducao != null) {
                    oldFuncionarioOfPedidoProducaoCollectionPedidoProducao.getPedidoProducaoCollection().remove(pedidoProducaoCollectionPedidoProducao);
                    oldFuncionarioOfPedidoProducaoCollectionPedidoProducao = em.merge(oldFuncionarioOfPedidoProducaoCollectionPedidoProducao);
                }
            }
            for (Cliente clienteCollectionCliente : funcionario.getClienteCollection()) {
                Funcionario oldFuncionarioOfClienteCollectionCliente = clienteCollectionCliente.getFuncionario();
                clienteCollectionCliente.setFuncionario(funcionario);
                clienteCollectionCliente = em.merge(clienteCollectionCliente);
                if (oldFuncionarioOfClienteCollectionCliente != null) {
                    oldFuncionarioOfClienteCollectionCliente.getClienteCollection().remove(clienteCollectionCliente);
                    oldFuncionarioOfClienteCollectionCliente = em.merge(oldFuncionarioOfClienteCollectionCliente);
                }
            }
            for (PedidoVenda pedidoVendaCollectionPedidoVenda : funcionario.getPedidoVendaCollection()) {
                Funcionario oldFuncionarioOfPedidoVendaCollectionPedidoVenda = pedidoVendaCollectionPedidoVenda.getFuncionario();
                pedidoVendaCollectionPedidoVenda.setFuncionario(funcionario);
                pedidoVendaCollectionPedidoVenda = em.merge(pedidoVendaCollectionPedidoVenda);
                if (oldFuncionarioOfPedidoVendaCollectionPedidoVenda != null) {
                    oldFuncionarioOfPedidoVendaCollectionPedidoVenda.getPedidoVendaCollection().remove(pedidoVendaCollectionPedidoVenda);
                    oldFuncionarioOfPedidoVendaCollectionPedidoVenda = em.merge(oldFuncionarioOfPedidoVendaCollectionPedidoVenda);
                }
            }
            em.getTransaction().commit();
        } catch (Exception ex) {
            if (findFuncionario(funcionario.getId()) != null) {
                throw new PreexistingEntityException("Funcionario " + funcionario + " already exists.", ex);
            }
            throw ex;
        } finally {
            if (em != null) {
                em.close();
            }
        }
    }

    public void edit(Funcionario funcionario) throws IllegalOrphanException, NonexistentEntityException, Exception {
        EntityManager em = null;
        try {
            em = getEntityManager();
            em.getTransaction().begin();
            Funcionario persistentFuncionario = em.find(Funcionario.class, funcionario.getId());
            Collection<PedidoCompra> pedidoCompraCollectionOld = persistentFuncionario.getPedidoCompraCollection();
            Collection<PedidoCompra> pedidoCompraCollectionNew = funcionario.getPedidoCompraCollection();
            Collection<PedidoProducao> pedidoProducaoCollectionOld = persistentFuncionario.getPedidoProducaoCollection();
            Collection<PedidoProducao> pedidoProducaoCollectionNew = funcionario.getPedidoProducaoCollection();
            Collection<Cliente> clienteCollectionOld = persistentFuncionario.getClienteCollection();
            Collection<Cliente> clienteCollectionNew = funcionario.getClienteCollection();
            Collection<PedidoVenda> pedidoVendaCollectionOld = persistentFuncionario.getPedidoVendaCollection();
            Collection<PedidoVenda> pedidoVendaCollectionNew = funcionario.getPedidoVendaCollection();
            List<String> illegalOrphanMessages = null;
            for (PedidoCompra pedidoCompraCollectionOldPedidoCompra : pedidoCompraCollectionOld) {
                if (!pedidoCompraCollectionNew.contains(pedidoCompraCollectionOldPedidoCompra)) {
                    if (illegalOrphanMessages == null) {
                        illegalOrphanMessages = new ArrayList<String>();
                    }
                    illegalOrphanMessages.add("You must retain PedidoCompra " + pedidoCompraCollectionOldPedidoCompra + " since its funcionario field is not nullable.");
                }
            }
            for (PedidoProducao pedidoProducaoCollectionOldPedidoProducao : pedidoProducaoCollectionOld) {
                if (!pedidoProducaoCollectionNew.contains(pedidoProducaoCollectionOldPedidoProducao)) {
                    if (illegalOrphanMessages == null) {
                        illegalOrphanMessages = new ArrayList<String>();
                    }
                    illegalOrphanMessages.add("You must retain PedidoProducao " + pedidoProducaoCollectionOldPedidoProducao + " since its funcionario field is not nullable.");
                }
            }
            for (PedidoVenda pedidoVendaCollectionOldPedidoVenda : pedidoVendaCollectionOld) {
                if (!pedidoVendaCollectionNew.contains(pedidoVendaCollectionOldPedidoVenda)) {
                    if (illegalOrphanMessages == null) {
                        illegalOrphanMessages = new ArrayList<String>();
                    }
                    illegalOrphanMessages.add("You must retain PedidoVenda " + pedidoVendaCollectionOldPedidoVenda + " since its funcionario field is not nullable.");
                }
            }
            if (illegalOrphanMessages != null) {
                throw new IllegalOrphanException(illegalOrphanMessages);
            }
            Collection<PedidoCompra> attachedPedidoCompraCollectionNew = new ArrayList<PedidoCompra>();
            for (PedidoCompra pedidoCompraCollectionNewPedidoCompraToAttach : pedidoCompraCollectionNew) {
                pedidoCompraCollectionNewPedidoCompraToAttach = em.getReference(pedidoCompraCollectionNewPedidoCompraToAttach.getClass(), pedidoCompraCollectionNewPedidoCompraToAttach.getId());
                attachedPedidoCompraCollectionNew.add(pedidoCompraCollectionNewPedidoCompraToAttach);
            }
            pedidoCompraCollectionNew = attachedPedidoCompraCollectionNew;
            funcionario.setPedidoCompraCollection(pedidoCompraCollectionNew);
            Collection<PedidoProducao> attachedPedidoProducaoCollectionNew = new ArrayList<PedidoProducao>();
            for (PedidoProducao pedidoProducaoCollectionNewPedidoProducaoToAttach : pedidoProducaoCollectionNew) {
                pedidoProducaoCollectionNewPedidoProducaoToAttach = em.getReference(pedidoProducaoCollectionNewPedidoProducaoToAttach.getClass(), pedidoProducaoCollectionNewPedidoProducaoToAttach.getId());
                attachedPedidoProducaoCollectionNew.add(pedidoProducaoCollectionNewPedidoProducaoToAttach);
            }
            pedidoProducaoCollectionNew = attachedPedidoProducaoCollectionNew;
            funcionario.setPedidoProducaoCollection(pedidoProducaoCollectionNew);
            Collection<Cliente> attachedClienteCollectionNew = new ArrayList<Cliente>();
            for (Cliente clienteCollectionNewClienteToAttach : clienteCollectionNew) {
                clienteCollectionNewClienteToAttach = em.getReference(clienteCollectionNewClienteToAttach.getClass(), clienteCollectionNewClienteToAttach.getId());
                attachedClienteCollectionNew.add(clienteCollectionNewClienteToAttach);
            }
            clienteCollectionNew = attachedClienteCollectionNew;
            funcionario.setClienteCollection(clienteCollectionNew);
            Collection<PedidoVenda> attachedPedidoVendaCollectionNew = new ArrayList<PedidoVenda>();
            for (PedidoVenda pedidoVendaCollectionNewPedidoVendaToAttach : pedidoVendaCollectionNew) {
                pedidoVendaCollectionNewPedidoVendaToAttach = em.getReference(pedidoVendaCollectionNewPedidoVendaToAttach.getClass(), pedidoVendaCollectionNewPedidoVendaToAttach.getId());
                attachedPedidoVendaCollectionNew.add(pedidoVendaCollectionNewPedidoVendaToAttach);
            }
            pedidoVendaCollectionNew = attachedPedidoVendaCollectionNew;
            funcionario.setPedidoVendaCollection(pedidoVendaCollectionNew);
            funcionario = em.merge(funcionario);
            for (PedidoCompra pedidoCompraCollectionNewPedidoCompra : pedidoCompraCollectionNew) {
                if (!pedidoCompraCollectionOld.contains(pedidoCompraCollectionNewPedidoCompra)) {
                    Funcionario oldFuncionarioOfPedidoCompraCollectionNewPedidoCompra = pedidoCompraCollectionNewPedidoCompra.getFuncionario();
                    pedidoCompraCollectionNewPedidoCompra.setFuncionario(funcionario);
                    pedidoCompraCollectionNewPedidoCompra = em.merge(pedidoCompraCollectionNewPedidoCompra);
                    if (oldFuncionarioOfPedidoCompraCollectionNewPedidoCompra != null && !oldFuncionarioOfPedidoCompraCollectionNewPedidoCompra.equals(funcionario)) {
                        oldFuncionarioOfPedidoCompraCollectionNewPedidoCompra.getPedidoCompraCollection().remove(pedidoCompraCollectionNewPedidoCompra);
                        oldFuncionarioOfPedidoCompraCollectionNewPedidoCompra = em.merge(oldFuncionarioOfPedidoCompraCollectionNewPedidoCompra);
                    }
                }
            }
            for (PedidoProducao pedidoProducaoCollectionNewPedidoProducao : pedidoProducaoCollectionNew) {
                if (!pedidoProducaoCollectionOld.contains(pedidoProducaoCollectionNewPedidoProducao)) {
                    Funcionario oldFuncionarioOfPedidoProducaoCollectionNewPedidoProducao = pedidoProducaoCollectionNewPedidoProducao.getFuncionario();
                    pedidoProducaoCollectionNewPedidoProducao.setFuncionario(funcionario);
                    pedidoProducaoCollectionNewPedidoProducao = em.merge(pedidoProducaoCollectionNewPedidoProducao);
                    if (oldFuncionarioOfPedidoProducaoCollectionNewPedidoProducao != null && !oldFuncionarioOfPedidoProducaoCollectionNewPedidoProducao.equals(funcionario)) {
                        oldFuncionarioOfPedidoProducaoCollectionNewPedidoProducao.getPedidoProducaoCollection().remove(pedidoProducaoCollectionNewPedidoProducao);
                        oldFuncionarioOfPedidoProducaoCollectionNewPedidoProducao = em.merge(oldFuncionarioOfPedidoProducaoCollectionNewPedidoProducao);
                    }
                }
            }
            for (Cliente clienteCollectionOldCliente : clienteCollectionOld) {
                if (!clienteCollectionNew.contains(clienteCollectionOldCliente)) {
                    clienteCollectionOldCliente.setFuncionario(null);
                    clienteCollectionOldCliente = em.merge(clienteCollectionOldCliente);
                }
            }
            for (Cliente clienteCollectionNewCliente : clienteCollectionNew) {
                if (!clienteCollectionOld.contains(clienteCollectionNewCliente)) {
                    Funcionario oldFuncionarioOfClienteCollectionNewCliente = clienteCollectionNewCliente.getFuncionario();
                    clienteCollectionNewCliente.setFuncionario(funcionario);
                    clienteCollectionNewCliente = em.merge(clienteCollectionNewCliente);
                    if (oldFuncionarioOfClienteCollectionNewCliente != null && !oldFuncionarioOfClienteCollectionNewCliente.equals(funcionario)) {
                        oldFuncionarioOfClienteCollectionNewCliente.getClienteCollection().remove(clienteCollectionNewCliente);
                        oldFuncionarioOfClienteCollectionNewCliente = em.merge(oldFuncionarioOfClienteCollectionNewCliente);
                    }
                }
            }
            for (PedidoVenda pedidoVendaCollectionNewPedidoVenda : pedidoVendaCollectionNew) {
                if (!pedidoVendaCollectionOld.contains(pedidoVendaCollectionNewPedidoVenda)) {
                    Funcionario oldFuncionarioOfPedidoVendaCollectionNewPedidoVenda = pedidoVendaCollectionNewPedidoVenda.getFuncionario();
                    pedidoVendaCollectionNewPedidoVenda.setFuncionario(funcionario);
                    pedidoVendaCollectionNewPedidoVenda = em.merge(pedidoVendaCollectionNewPedidoVenda);
                    if (oldFuncionarioOfPedidoVendaCollectionNewPedidoVenda != null && !oldFuncionarioOfPedidoVendaCollectionNewPedidoVenda.equals(funcionario)) {
                        oldFuncionarioOfPedidoVendaCollectionNewPedidoVenda.getPedidoVendaCollection().remove(pedidoVendaCollectionNewPedidoVenda);
                        oldFuncionarioOfPedidoVendaCollectionNewPedidoVenda = em.merge(oldFuncionarioOfPedidoVendaCollectionNewPedidoVenda);
                    }
                }
            }
            em.getTransaction().commit();
        } catch (Exception ex) {
            String msg = ex.getLocalizedMessage();
            if (msg == null || msg.length() == 0) {
                Integer id = funcionario.getId();
                if (findFuncionario(id) == null) {
                    throw new NonexistentEntityException("The funcionario with id " + id + " no longer exists.");
                }
            }
            throw ex;
        } finally {
            if (em != null) {
                em.close();
            }
        }
    }

    public void destroy(Integer id) throws IllegalOrphanException, NonexistentEntityException {
        EntityManager em = null;
        try {
            em = getEntityManager();
            em.getTransaction().begin();
            Funcionario funcionario;
            try {
                funcionario = em.getReference(Funcionario.class, id);
                funcionario.getId();
            } catch (EntityNotFoundException enfe) {
                throw new NonexistentEntityException("The funcionario with id " + id + " no longer exists.", enfe);
            }
            List<String> illegalOrphanMessages = null;
            Collection<PedidoCompra> pedidoCompraCollectionOrphanCheck = funcionario.getPedidoCompraCollection();
            for (PedidoCompra pedidoCompraCollectionOrphanCheckPedidoCompra : pedidoCompraCollectionOrphanCheck) {
                if (illegalOrphanMessages == null) {
                    illegalOrphanMessages = new ArrayList<String>();
                }
                illegalOrphanMessages.add("This Funcionario (" + funcionario + ") cannot be destroyed since the PedidoCompra " + pedidoCompraCollectionOrphanCheckPedidoCompra + " in its pedidoCompraCollection field has a non-nullable funcionario field.");
            }
            Collection<PedidoProducao> pedidoProducaoCollectionOrphanCheck = funcionario.getPedidoProducaoCollection();
            for (PedidoProducao pedidoProducaoCollectionOrphanCheckPedidoProducao : pedidoProducaoCollectionOrphanCheck) {
                if (illegalOrphanMessages == null) {
                    illegalOrphanMessages = new ArrayList<String>();
                }
                illegalOrphanMessages.add("This Funcionario (" + funcionario + ") cannot be destroyed since the PedidoProducao " + pedidoProducaoCollectionOrphanCheckPedidoProducao + " in its pedidoProducaoCollection field has a non-nullable funcionario field.");
            }
            Collection<PedidoVenda> pedidoVendaCollectionOrphanCheck = funcionario.getPedidoVendaCollection();
            for (PedidoVenda pedidoVendaCollectionOrphanCheckPedidoVenda : pedidoVendaCollectionOrphanCheck) {
                if (illegalOrphanMessages == null) {
                    illegalOrphanMessages = new ArrayList<String>();
                }
                illegalOrphanMessages.add("This Funcionario (" + funcionario + ") cannot be destroyed since the PedidoVenda " + pedidoVendaCollectionOrphanCheckPedidoVenda + " in its pedidoVendaCollection field has a non-nullable funcionario field.");
            }
            if (illegalOrphanMessages != null) {
                throw new IllegalOrphanException(illegalOrphanMessages);
            }
            Collection<Cliente> clienteCollection = funcionario.getClienteCollection();
            for (Cliente clienteCollectionCliente : clienteCollection) {
                clienteCollectionCliente.setFuncionario(null);
                clienteCollectionCliente = em.merge(clienteCollectionCliente);
            }
            em.remove(funcionario);
            em.getTransaction().commit();
        } finally {
            if (em != null) {
                em.close();
            }
        }
    }

    public List<Funcionario> findFuncionarioEntities() {
        return findFuncionarioEntities(true, -1, -1);
    }

    public List<Funcionario> findFuncionarioEntities(int maxResults, int firstResult) {
        return findFuncionarioEntities(false, maxResults, firstResult);
    }

    private List<Funcionario> findFuncionarioEntities(boolean all, int maxResults, int firstResult) {
        EntityManager em = getEntityManager();
        try {
            Query q = em.createQuery("select object(o) from Funcionario as o");
            if (!all) {
                q.setMaxResults(maxResults);
                q.setFirstResult(firstResult);
            }
            return q.getResultList();
        } finally {
            em.close();
        }
    }

    public Funcionario findFuncionario(Integer id) {
        EntityManager em = getEntityManager();
        try {
            return em.find(Funcionario.class, id);
        } finally {
            em.close();
        }
    }

    public int getFuncionarioCount() {
        EntityManager em = getEntityManager();
        try {
            Query q = em.createQuery("select count(o) from Funcionario as o");
            return ((Long) q.getSingleResult()).intValue();
        } finally {
            em.close();
        }
    }

}
