/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package modelo.controle;

import java.util.List;
import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;
import javax.persistence.Query;
import javax.persistence.EntityNotFoundException;
import modelo.Funcionario;
import modelo.Cliente;
import modelo.PedidoVenda;
import modelo.Venda;
import java.util.ArrayList;
import java.util.Collection;
import modelo.controle.exceptions.IllegalOrphanException;
import modelo.controle.exceptions.NonexistentEntityException;
import modelo.controle.exceptions.PreexistingEntityException;

/**
 *
 * @author willian
 */
public class PedidoVendaJpaController {

    public PedidoVendaJpaController() {
        emf = Persistence.createEntityManagerFactory("EstoquePU");
    }
    private EntityManagerFactory emf = null;

    public EntityManager getEntityManager() {
        return emf.createEntityManager();
    }

    public void create(PedidoVenda pedidoVenda) throws PreexistingEntityException, Exception {
        if (pedidoVenda.getVendaCollection() == null) {
            pedidoVenda.setVendaCollection(new ArrayList<Venda>());
        }
        EntityManager em = null;
        try {
            em = getEntityManager();
            em.getTransaction().begin();
            Funcionario funcionario = pedidoVenda.getFuncionario();
            if (funcionario != null) {
                funcionario = em.getReference(funcionario.getClass(), funcionario.getId());
                pedidoVenda.setFuncionario(funcionario);
            }
            Cliente cliente = pedidoVenda.getCliente();
            if (cliente != null) {
                cliente = em.getReference(cliente.getClass(), cliente.getId());
                pedidoVenda.setCliente(cliente);
            }
            Collection<Venda> attachedVendaCollection = new ArrayList<Venda>();
            for (Venda vendaCollectionVendaToAttach : pedidoVenda.getVendaCollection()) {
                vendaCollectionVendaToAttach = em.getReference(vendaCollectionVendaToAttach.getClass(), vendaCollectionVendaToAttach.getVendaPK());
                attachedVendaCollection.add(vendaCollectionVendaToAttach);
            }
            pedidoVenda.setVendaCollection(attachedVendaCollection);
            em.persist(pedidoVenda);
            if (funcionario != null) {
                funcionario.getPedidoVendaCollection().add(pedidoVenda);
                funcionario = em.merge(funcionario);
            }
            if (cliente != null) {
                cliente.getPedidoVendaCollection().add(pedidoVenda);
                cliente = em.merge(cliente);
            }
            for (Venda vendaCollectionVenda : pedidoVenda.getVendaCollection()) {
                PedidoVenda oldPedidoVendaOfVendaCollectionVenda = vendaCollectionVenda.getPedidoVenda();
                vendaCollectionVenda.setPedidoVenda(pedidoVenda);
                vendaCollectionVenda = em.merge(vendaCollectionVenda);
                if (oldPedidoVendaOfVendaCollectionVenda != null) {
                    oldPedidoVendaOfVendaCollectionVenda.getVendaCollection().remove(vendaCollectionVenda);
                    oldPedidoVendaOfVendaCollectionVenda = em.merge(oldPedidoVendaOfVendaCollectionVenda);
                }
            }
            em.getTransaction().commit();
        } catch (Exception ex) {
            if (findPedidoVenda(pedidoVenda.getId()) != null) {
                throw new PreexistingEntityException("PedidoVenda " + pedidoVenda + " already exists.", ex);
            }
            throw ex;
        } finally {
            if (em != null) {
                em.close();
            }
        }
    }

    public void edit(PedidoVenda pedidoVenda) throws IllegalOrphanException, NonexistentEntityException, Exception {
        EntityManager em = null;
        try {
            em = getEntityManager();
            em.getTransaction().begin();
            PedidoVenda persistentPedidoVenda = em.find(PedidoVenda.class, pedidoVenda.getId());
            Funcionario funcionarioOld = persistentPedidoVenda.getFuncionario();
            Funcionario funcionarioNew = pedidoVenda.getFuncionario();
            Cliente clienteOld = persistentPedidoVenda.getCliente();
            Cliente clienteNew = pedidoVenda.getCliente();
            Collection<Venda> vendaCollectionOld = persistentPedidoVenda.getVendaCollection();
            Collection<Venda> vendaCollectionNew = pedidoVenda.getVendaCollection();
            List<String> illegalOrphanMessages = null;
            for (Venda vendaCollectionOldVenda : vendaCollectionOld) {
                if (!vendaCollectionNew.contains(vendaCollectionOldVenda)) {
                    if (illegalOrphanMessages == null) {
                        illegalOrphanMessages = new ArrayList<String>();
                    }
                    illegalOrphanMessages.add("You must retain Venda " + vendaCollectionOldVenda + " since its pedidoVenda field is not nullable.");
                }
            }
            if (illegalOrphanMessages != null) {
                throw new IllegalOrphanException(illegalOrphanMessages);
            }
            if (funcionarioNew != null) {
                funcionarioNew = em.getReference(funcionarioNew.getClass(), funcionarioNew.getId());
                pedidoVenda.setFuncionario(funcionarioNew);
            }
            if (clienteNew != null) {
                clienteNew = em.getReference(clienteNew.getClass(), clienteNew.getId());
                pedidoVenda.setCliente(clienteNew);
            }
            Collection<Venda> attachedVendaCollectionNew = new ArrayList<Venda>();
            for (Venda vendaCollectionNewVendaToAttach : vendaCollectionNew) {
                vendaCollectionNewVendaToAttach = em.getReference(vendaCollectionNewVendaToAttach.getClass(), vendaCollectionNewVendaToAttach.getVendaPK());
                attachedVendaCollectionNew.add(vendaCollectionNewVendaToAttach);
            }
            vendaCollectionNew = attachedVendaCollectionNew;
            pedidoVenda.setVendaCollection(vendaCollectionNew);
            pedidoVenda = em.merge(pedidoVenda);
            if (funcionarioOld != null && !funcionarioOld.equals(funcionarioNew)) {
                funcionarioOld.getPedidoVendaCollection().remove(pedidoVenda);
                funcionarioOld = em.merge(funcionarioOld);
            }
            if (funcionarioNew != null && !funcionarioNew.equals(funcionarioOld)) {
                funcionarioNew.getPedidoVendaCollection().add(pedidoVenda);
                funcionarioNew = em.merge(funcionarioNew);
            }
            if (clienteOld != null && !clienteOld.equals(clienteNew)) {
                clienteOld.getPedidoVendaCollection().remove(pedidoVenda);
                clienteOld = em.merge(clienteOld);
            }
            if (clienteNew != null && !clienteNew.equals(clienteOld)) {
                clienteNew.getPedidoVendaCollection().add(pedidoVenda);
                clienteNew = em.merge(clienteNew);
            }
            for (Venda vendaCollectionNewVenda : vendaCollectionNew) {
                if (!vendaCollectionOld.contains(vendaCollectionNewVenda)) {
                    PedidoVenda oldPedidoVendaOfVendaCollectionNewVenda = vendaCollectionNewVenda.getPedidoVenda();
                    vendaCollectionNewVenda.setPedidoVenda(pedidoVenda);
                    vendaCollectionNewVenda = em.merge(vendaCollectionNewVenda);
                    if (oldPedidoVendaOfVendaCollectionNewVenda != null && !oldPedidoVendaOfVendaCollectionNewVenda.equals(pedidoVenda)) {
                        oldPedidoVendaOfVendaCollectionNewVenda.getVendaCollection().remove(vendaCollectionNewVenda);
                        oldPedidoVendaOfVendaCollectionNewVenda = em.merge(oldPedidoVendaOfVendaCollectionNewVenda);
                    }
                }
            }
            em.getTransaction().commit();
        } catch (Exception ex) {
            String msg = ex.getLocalizedMessage();
            if (msg == null || msg.length() == 0) {
                Integer id = pedidoVenda.getId();
                if (findPedidoVenda(id) == null) {
                    throw new NonexistentEntityException("The pedidoVenda with id " + id + " no longer exists.");
                }
            }
            throw ex;
        } finally {
            if (em != null) {
                em.close();
            }
        }
    }

    public void destroy(Integer id) throws IllegalOrphanException, NonexistentEntityException {
        EntityManager em = null;
        try {
            em = getEntityManager();
            em.getTransaction().begin();
            PedidoVenda pedidoVenda;
            try {
                pedidoVenda = em.getReference(PedidoVenda.class, id);
                pedidoVenda.getId();
            } catch (EntityNotFoundException enfe) {
                throw new NonexistentEntityException("The pedidoVenda with id " + id + " no longer exists.", enfe);
            }
            List<String> illegalOrphanMessages = null;
            Collection<Venda> vendaCollectionOrphanCheck = pedidoVenda.getVendaCollection();
            for (Venda vendaCollectionOrphanCheckVenda : vendaCollectionOrphanCheck) {
                if (illegalOrphanMessages == null) {
                    illegalOrphanMessages = new ArrayList<String>();
                }
                illegalOrphanMessages.add("This PedidoVenda (" + pedidoVenda + ") cannot be destroyed since the Venda " + vendaCollectionOrphanCheckVenda + " in its vendaCollection field has a non-nullable pedidoVenda field.");
            }
            if (illegalOrphanMessages != null) {
                throw new IllegalOrphanException(illegalOrphanMessages);
            }
            Funcionario funcionario = pedidoVenda.getFuncionario();
            if (funcionario != null) {
                funcionario.getPedidoVendaCollection().remove(pedidoVenda);
                funcionario = em.merge(funcionario);
            }
            Cliente cliente = pedidoVenda.getCliente();
            if (cliente != null) {
                cliente.getPedidoVendaCollection().remove(pedidoVenda);
                cliente = em.merge(cliente);
            }
            em.remove(pedidoVenda);
            em.getTransaction().commit();
        } finally {
            if (em != null) {
                em.close();
            }
        }
    }

    public List<PedidoVenda> findPedidoVendaEntities() {
        return findPedidoVendaEntities(true, -1, -1);
    }

    public List<PedidoVenda> findPedidoVendaEntities(int maxResults, int firstResult) {
        return findPedidoVendaEntities(false, maxResults, firstResult);
    }

    private List<PedidoVenda> findPedidoVendaEntities(boolean all, int maxResults, int firstResult) {
        EntityManager em = getEntityManager();
        try {
            Query q = em.createQuery("select object(o) from PedidoVenda as o");
            if (!all) {
                q.setMaxResults(maxResults);
                q.setFirstResult(firstResult);
            }
            return q.getResultList();
        } finally {
            em.close();
        }
    }

    public PedidoVenda findPedidoVenda(Integer id) {
        EntityManager em = getEntityManager();
        try {
            return em.find(PedidoVenda.class, id);
        } finally {
            em.close();
        }
    }

    public int getPedidoVendaCount() {
        EntityManager em = getEntityManager();
        try {
            Query q = em.createQuery("select count(o) from PedidoVenda as o");
            return ((Long) q.getSingleResult()).intValue();
        } finally {
            em.close();
        }
    }

}
