/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package modelo.controle;

import java.util.List;
import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;
import javax.persistence.Query;
import javax.persistence.EntityNotFoundException;
import modelo.PedidoProducao;
import java.util.ArrayList;
import java.util.Collection;
import modelo.Produto;
import modelo.Venda;
import modelo.Fornece;
import modelo.Compra;
import modelo.Compoe;
import modelo.controle.exceptions.IllegalOrphanException;
import modelo.controle.exceptions.NonexistentEntityException;
import modelo.controle.exceptions.PreexistingEntityException;

/**
 *
 * @author willian
 */
public class ProdutoJpaController {

    public ProdutoJpaController() {
        emf = Persistence.createEntityManagerFactory("EstoquePU");
    }
    private EntityManagerFactory emf = null;

    public EntityManager getEntityManager() {
        return emf.createEntityManager();
    }

    public void create(Produto produto) throws PreexistingEntityException, Exception {
        if (produto.getPedidoProducaoCollection() == null) {
            produto.setPedidoProducaoCollection(new ArrayList<PedidoProducao>());
        }
        if (produto.getVendaCollection() == null) {
            produto.setVendaCollection(new ArrayList<Venda>());
        }
        if (produto.getForneceCollection() == null) {
            produto.setForneceCollection(new ArrayList<Fornece>());
        }
        if (produto.getCompraCollection() == null) {
            produto.setCompraCollection(new ArrayList<Compra>());
        }
        if (produto.getCompoeCollection() == null) {
            produto.setCompoeCollection(new ArrayList<Compoe>());
        }
        if (produto.getCompoeCollection1() == null) {
            produto.setCompoeCollection1(new ArrayList<Compoe>());
        }
        EntityManager em = null;
        try {
            em = getEntityManager();
            em.getTransaction().begin();
            Collection<PedidoProducao> attachedPedidoProducaoCollection = new ArrayList<PedidoProducao>();
            for (PedidoProducao pedidoProducaoCollectionPedidoProducaoToAttach : produto.getPedidoProducaoCollection()) {
                pedidoProducaoCollectionPedidoProducaoToAttach = em.getReference(pedidoProducaoCollectionPedidoProducaoToAttach.getClass(), pedidoProducaoCollectionPedidoProducaoToAttach.getId());
                attachedPedidoProducaoCollection.add(pedidoProducaoCollectionPedidoProducaoToAttach);
            }
            produto.setPedidoProducaoCollection(attachedPedidoProducaoCollection);
            Collection<Venda> attachedVendaCollection = new ArrayList<Venda>();
            for (Venda vendaCollectionVendaToAttach : produto.getVendaCollection()) {
                vendaCollectionVendaToAttach = em.getReference(vendaCollectionVendaToAttach.getClass(), vendaCollectionVendaToAttach.getVendaPK());
                attachedVendaCollection.add(vendaCollectionVendaToAttach);
            }
            produto.setVendaCollection(attachedVendaCollection);
            Collection<Fornece> attachedForneceCollection = new ArrayList<Fornece>();
            for (Fornece forneceCollectionForneceToAttach : produto.getForneceCollection()) {
                forneceCollectionForneceToAttach = em.getReference(forneceCollectionForneceToAttach.getClass(), forneceCollectionForneceToAttach.getFornecePK());
                attachedForneceCollection.add(forneceCollectionForneceToAttach);
            }
            produto.setForneceCollection(attachedForneceCollection);
            Collection<Compra> attachedCompraCollection = new ArrayList<Compra>();
            for (Compra compraCollectionCompraToAttach : produto.getCompraCollection()) {
                compraCollectionCompraToAttach = em.getReference(compraCollectionCompraToAttach.getClass(), compraCollectionCompraToAttach.getCompraPK());
                attachedCompraCollection.add(compraCollectionCompraToAttach);
            }
            produto.setCompraCollection(attachedCompraCollection);
            Collection<Compoe> attachedCompoeCollection = new ArrayList<Compoe>();
            for (Compoe compoeCollectionCompoeToAttach : produto.getCompoeCollection()) {
                compoeCollectionCompoeToAttach = em.getReference(compoeCollectionCompoeToAttach.getClass(), compoeCollectionCompoeToAttach.getCompoePK());
                attachedCompoeCollection.add(compoeCollectionCompoeToAttach);
            }
            produto.setCompoeCollection(attachedCompoeCollection);
            Collection<Compoe> attachedCompoeCollection1 = new ArrayList<Compoe>();
            for (Compoe compoeCollection1CompoeToAttach : produto.getCompoeCollection1()) {
                compoeCollection1CompoeToAttach = em.getReference(compoeCollection1CompoeToAttach.getClass(), compoeCollection1CompoeToAttach.getCompoePK());
                attachedCompoeCollection1.add(compoeCollection1CompoeToAttach);
            }
            produto.setCompoeCollection1(attachedCompoeCollection1);
            em.persist(produto);
            for (PedidoProducao pedidoProducaoCollectionPedidoProducao : produto.getPedidoProducaoCollection()) {
                Produto oldProdutoOfPedidoProducaoCollectionPedidoProducao = pedidoProducaoCollectionPedidoProducao.getProduto();
                pedidoProducaoCollectionPedidoProducao.setProduto(produto);
                pedidoProducaoCollectionPedidoProducao = em.merge(pedidoProducaoCollectionPedidoProducao);
                if (oldProdutoOfPedidoProducaoCollectionPedidoProducao != null) {
                    oldProdutoOfPedidoProducaoCollectionPedidoProducao.getPedidoProducaoCollection().remove(pedidoProducaoCollectionPedidoProducao);
                    oldProdutoOfPedidoProducaoCollectionPedidoProducao = em.merge(oldProdutoOfPedidoProducaoCollectionPedidoProducao);
                }
            }
            for (Venda vendaCollectionVenda : produto.getVendaCollection()) {
                Produto oldProdutoOfVendaCollectionVenda = vendaCollectionVenda.getProduto();
                vendaCollectionVenda.setProduto(produto);
                vendaCollectionVenda = em.merge(vendaCollectionVenda);
                if (oldProdutoOfVendaCollectionVenda != null) {
                    oldProdutoOfVendaCollectionVenda.getVendaCollection().remove(vendaCollectionVenda);
                    oldProdutoOfVendaCollectionVenda = em.merge(oldProdutoOfVendaCollectionVenda);
                }
            }
            for (Fornece forneceCollectionFornece : produto.getForneceCollection()) {
                Produto oldProdutoOfForneceCollectionFornece = forneceCollectionFornece.getProduto();
                forneceCollectionFornece.setProduto(produto);
                forneceCollectionFornece = em.merge(forneceCollectionFornece);
                if (oldProdutoOfForneceCollectionFornece != null) {
                    oldProdutoOfForneceCollectionFornece.getForneceCollection().remove(forneceCollectionFornece);
                    oldProdutoOfForneceCollectionFornece = em.merge(oldProdutoOfForneceCollectionFornece);
                }
            }
            for (Compra compraCollectionCompra : produto.getCompraCollection()) {
                Produto oldProdutoOfCompraCollectionCompra = compraCollectionCompra.getProduto();
                compraCollectionCompra.setProduto(produto);
                compraCollectionCompra = em.merge(compraCollectionCompra);
                if (oldProdutoOfCompraCollectionCompra != null) {
                    oldProdutoOfCompraCollectionCompra.getCompraCollection().remove(compraCollectionCompra);
                    oldProdutoOfCompraCollectionCompra = em.merge(oldProdutoOfCompraCollectionCompra);
                }
            }
            for (Compoe compoeCollectionCompoe : produto.getCompoeCollection()) {
                Produto oldProdutoOfCompoeCollectionCompoe = compoeCollectionCompoe.getParte();
                compoeCollectionCompoe.setParte(produto);
                compoeCollectionCompoe = em.merge(compoeCollectionCompoe);
                if (oldProdutoOfCompoeCollectionCompoe != null) {
                    oldProdutoOfCompoeCollectionCompoe.getCompoeCollection().remove(compoeCollectionCompoe);
                    oldProdutoOfCompoeCollectionCompoe = em.merge(oldProdutoOfCompoeCollectionCompoe);
                }
            }
            for (Compoe compoeCollection1Compoe : produto.getCompoeCollection1()) {
                Produto oldProduto1OfCompoeCollection1Compoe = compoeCollection1Compoe.getProduto();
                compoeCollection1Compoe.setProduto(produto);
                compoeCollection1Compoe = em.merge(compoeCollection1Compoe);
                if (oldProduto1OfCompoeCollection1Compoe != null) {
                    oldProduto1OfCompoeCollection1Compoe.getCompoeCollection1().remove(compoeCollection1Compoe);
                    oldProduto1OfCompoeCollection1Compoe = em.merge(oldProduto1OfCompoeCollection1Compoe);
                }
            }
            em.getTransaction().commit();
        } catch (Exception ex) {
            if (findProduto(produto.getId()) != null) {
                throw new PreexistingEntityException("Produto " + produto + " already exists.", ex);
            }
            throw ex;
        } finally {
            if (em != null) {
                em.close();
            }
        }
    }

    public void edit(Produto produto) throws IllegalOrphanException, NonexistentEntityException, Exception {
        EntityManager em = null;
        try {
            em = getEntityManager();
            em.getTransaction().begin();
            Produto persistentProduto = em.find(Produto.class, produto.getId());
            Collection<PedidoProducao> pedidoProducaoCollectionOld = persistentProduto.getPedidoProducaoCollection();
            Collection<PedidoProducao> pedidoProducaoCollectionNew = produto.getPedidoProducaoCollection();
            Collection<Venda> vendaCollectionOld = persistentProduto.getVendaCollection();
            Collection<Venda> vendaCollectionNew = produto.getVendaCollection();
            Collection<Fornece> forneceCollectionOld = persistentProduto.getForneceCollection();
            Collection<Fornece> forneceCollectionNew = produto.getForneceCollection();
            Collection<Compra> compraCollectionOld = persistentProduto.getCompraCollection();
            Collection<Compra> compraCollectionNew = produto.getCompraCollection();
            Collection<Compoe> compoeCollectionOld = persistentProduto.getCompoeCollection();
            Collection<Compoe> compoeCollectionNew = produto.getCompoeCollection();
            Collection<Compoe> compoeCollection1Old = persistentProduto.getCompoeCollection1();
            Collection<Compoe> compoeCollection1New = produto.getCompoeCollection1();
            List<String> illegalOrphanMessages = null;
            for (PedidoProducao pedidoProducaoCollectionOldPedidoProducao : pedidoProducaoCollectionOld) {
                if (!pedidoProducaoCollectionNew.contains(pedidoProducaoCollectionOldPedidoProducao)) {
                    if (illegalOrphanMessages == null) {
                        illegalOrphanMessages = new ArrayList<String>();
                    }
                    illegalOrphanMessages.add("You must retain PedidoProducao " + pedidoProducaoCollectionOldPedidoProducao + " since its produto field is not nullable.");
                }
            }
            for (Venda vendaCollectionOldVenda : vendaCollectionOld) {
                if (!vendaCollectionNew.contains(vendaCollectionOldVenda)) {
                    if (illegalOrphanMessages == null) {
                        illegalOrphanMessages = new ArrayList<String>();
                    }
                    illegalOrphanMessages.add("You must retain Venda " + vendaCollectionOldVenda + " since its produto field is not nullable.");
                }
            }
            for (Fornece forneceCollectionOldFornece : forneceCollectionOld) {
                if (!forneceCollectionNew.contains(forneceCollectionOldFornece)) {
                    if (illegalOrphanMessages == null) {
                        illegalOrphanMessages = new ArrayList<String>();
                    }
                    illegalOrphanMessages.add("You must retain Fornece " + forneceCollectionOldFornece + " since its produto field is not nullable.");
                }
            }
            for (Compra compraCollectionOldCompra : compraCollectionOld) {
                if (!compraCollectionNew.contains(compraCollectionOldCompra)) {
                    if (illegalOrphanMessages == null) {
                        illegalOrphanMessages = new ArrayList<String>();
                    }
                    illegalOrphanMessages.add("You must retain Compra " + compraCollectionOldCompra + " since its produto field is not nullable.");
                }
            }
            for (Compoe compoeCollectionOldCompoe : compoeCollectionOld) {
                if (!compoeCollectionNew.contains(compoeCollectionOldCompoe)) {
                    if (illegalOrphanMessages == null) {
                        illegalOrphanMessages = new ArrayList<String>();
                    }
                    illegalOrphanMessages.add("You must retain Compoe " + compoeCollectionOldCompoe + " since its produto field is not nullable.");
                }
            }
            for (Compoe compoeCollection1OldCompoe : compoeCollection1Old) {
                if (!compoeCollection1New.contains(compoeCollection1OldCompoe)) {
                    if (illegalOrphanMessages == null) {
                        illegalOrphanMessages = new ArrayList<String>();
                    }
                    illegalOrphanMessages.add("You must retain Compoe " + compoeCollection1OldCompoe + " since its produto1 field is not nullable.");
                }
            }
            if (illegalOrphanMessages != null) {
                throw new IllegalOrphanException(illegalOrphanMessages);
            }
            Collection<PedidoProducao> attachedPedidoProducaoCollectionNew = new ArrayList<PedidoProducao>();
            for (PedidoProducao pedidoProducaoCollectionNewPedidoProducaoToAttach : pedidoProducaoCollectionNew) {
                pedidoProducaoCollectionNewPedidoProducaoToAttach = em.getReference(pedidoProducaoCollectionNewPedidoProducaoToAttach.getClass(), pedidoProducaoCollectionNewPedidoProducaoToAttach.getId());
                attachedPedidoProducaoCollectionNew.add(pedidoProducaoCollectionNewPedidoProducaoToAttach);
            }
            pedidoProducaoCollectionNew = attachedPedidoProducaoCollectionNew;
            produto.setPedidoProducaoCollection(pedidoProducaoCollectionNew);
            Collection<Venda> attachedVendaCollectionNew = new ArrayList<Venda>();
            for (Venda vendaCollectionNewVendaToAttach : vendaCollectionNew) {
                vendaCollectionNewVendaToAttach = em.getReference(vendaCollectionNewVendaToAttach.getClass(), vendaCollectionNewVendaToAttach.getVendaPK());
                attachedVendaCollectionNew.add(vendaCollectionNewVendaToAttach);
            }
            vendaCollectionNew = attachedVendaCollectionNew;
            produto.setVendaCollection(vendaCollectionNew);
            Collection<Fornece> attachedForneceCollectionNew = new ArrayList<Fornece>();
            for (Fornece forneceCollectionNewForneceToAttach : forneceCollectionNew) {
                forneceCollectionNewForneceToAttach = em.getReference(forneceCollectionNewForneceToAttach.getClass(), forneceCollectionNewForneceToAttach.getFornecePK());
                attachedForneceCollectionNew.add(forneceCollectionNewForneceToAttach);
            }
            forneceCollectionNew = attachedForneceCollectionNew;
            produto.setForneceCollection(forneceCollectionNew);
            Collection<Compra> attachedCompraCollectionNew = new ArrayList<Compra>();
            for (Compra compraCollectionNewCompraToAttach : compraCollectionNew) {
                compraCollectionNewCompraToAttach = em.getReference(compraCollectionNewCompraToAttach.getClass(), compraCollectionNewCompraToAttach.getCompraPK());
                attachedCompraCollectionNew.add(compraCollectionNewCompraToAttach);
            }
            compraCollectionNew = attachedCompraCollectionNew;
            produto.setCompraCollection(compraCollectionNew);
            Collection<Compoe> attachedCompoeCollectionNew = new ArrayList<Compoe>();
            for (Compoe compoeCollectionNewCompoeToAttach : compoeCollectionNew) {
                compoeCollectionNewCompoeToAttach = em.getReference(compoeCollectionNewCompoeToAttach.getClass(), compoeCollectionNewCompoeToAttach.getCompoePK());
                attachedCompoeCollectionNew.add(compoeCollectionNewCompoeToAttach);
            }
            compoeCollectionNew = attachedCompoeCollectionNew;
            produto.setCompoeCollection(compoeCollectionNew);
            Collection<Compoe> attachedCompoeCollection1New = new ArrayList<Compoe>();
            for (Compoe compoeCollection1NewCompoeToAttach : compoeCollection1New) {
                compoeCollection1NewCompoeToAttach = em.getReference(compoeCollection1NewCompoeToAttach.getClass(), compoeCollection1NewCompoeToAttach.getCompoePK());
                attachedCompoeCollection1New.add(compoeCollection1NewCompoeToAttach);
            }
            compoeCollection1New = attachedCompoeCollection1New;
            produto.setCompoeCollection1(compoeCollection1New);
            produto = em.merge(produto);
            for (PedidoProducao pedidoProducaoCollectionNewPedidoProducao : pedidoProducaoCollectionNew) {
                if (!pedidoProducaoCollectionOld.contains(pedidoProducaoCollectionNewPedidoProducao)) {
                    Produto oldProdutoOfPedidoProducaoCollectionNewPedidoProducao = pedidoProducaoCollectionNewPedidoProducao.getProduto();
                    pedidoProducaoCollectionNewPedidoProducao.setProduto(produto);
                    pedidoProducaoCollectionNewPedidoProducao = em.merge(pedidoProducaoCollectionNewPedidoProducao);
                    if (oldProdutoOfPedidoProducaoCollectionNewPedidoProducao != null && !oldProdutoOfPedidoProducaoCollectionNewPedidoProducao.equals(produto)) {
                        oldProdutoOfPedidoProducaoCollectionNewPedidoProducao.getPedidoProducaoCollection().remove(pedidoProducaoCollectionNewPedidoProducao);
                        oldProdutoOfPedidoProducaoCollectionNewPedidoProducao = em.merge(oldProdutoOfPedidoProducaoCollectionNewPedidoProducao);
                    }
                }
            }
            for (Venda vendaCollectionNewVenda : vendaCollectionNew) {
                if (!vendaCollectionOld.contains(vendaCollectionNewVenda)) {
                    Produto oldProdutoOfVendaCollectionNewVenda = vendaCollectionNewVenda.getProduto();
                    vendaCollectionNewVenda.setProduto(produto);
                    vendaCollectionNewVenda = em.merge(vendaCollectionNewVenda);
                    if (oldProdutoOfVendaCollectionNewVenda != null && !oldProdutoOfVendaCollectionNewVenda.equals(produto)) {
                        oldProdutoOfVendaCollectionNewVenda.getVendaCollection().remove(vendaCollectionNewVenda);
                        oldProdutoOfVendaCollectionNewVenda = em.merge(oldProdutoOfVendaCollectionNewVenda);
                    }
                }
            }
            for (Fornece forneceCollectionNewFornece : forneceCollectionNew) {
                if (!forneceCollectionOld.contains(forneceCollectionNewFornece)) {
                    Produto oldProdutoOfForneceCollectionNewFornece = forneceCollectionNewFornece.getProduto();
                    forneceCollectionNewFornece.setProduto(produto);
                    forneceCollectionNewFornece = em.merge(forneceCollectionNewFornece);
                    if (oldProdutoOfForneceCollectionNewFornece != null && !oldProdutoOfForneceCollectionNewFornece.equals(produto)) {
                        oldProdutoOfForneceCollectionNewFornece.getForneceCollection().remove(forneceCollectionNewFornece);
                        oldProdutoOfForneceCollectionNewFornece = em.merge(oldProdutoOfForneceCollectionNewFornece);
                    }
                }
            }
            for (Compra compraCollectionNewCompra : compraCollectionNew) {
                if (!compraCollectionOld.contains(compraCollectionNewCompra)) {
                    Produto oldProdutoOfCompraCollectionNewCompra = compraCollectionNewCompra.getProduto();
                    compraCollectionNewCompra.setProduto(produto);
                    compraCollectionNewCompra = em.merge(compraCollectionNewCompra);
                    if (oldProdutoOfCompraCollectionNewCompra != null && !oldProdutoOfCompraCollectionNewCompra.equals(produto)) {
                        oldProdutoOfCompraCollectionNewCompra.getCompraCollection().remove(compraCollectionNewCompra);
                        oldProdutoOfCompraCollectionNewCompra = em.merge(oldProdutoOfCompraCollectionNewCompra);
                    }
                }
            }
            for (Compoe compoeCollectionNewCompoe : compoeCollectionNew) {
                if (!compoeCollectionOld.contains(compoeCollectionNewCompoe)) {
                    Produto oldProdutoOfCompoeCollectionNewCompoe = compoeCollectionNewCompoe.getParte();
                    compoeCollectionNewCompoe.setParte(produto);
                    compoeCollectionNewCompoe = em.merge(compoeCollectionNewCompoe);
                    if (oldProdutoOfCompoeCollectionNewCompoe != null && !oldProdutoOfCompoeCollectionNewCompoe.equals(produto)) {
                        oldProdutoOfCompoeCollectionNewCompoe.getCompoeCollection().remove(compoeCollectionNewCompoe);
                        oldProdutoOfCompoeCollectionNewCompoe = em.merge(oldProdutoOfCompoeCollectionNewCompoe);
                    }
                }
            }
            for (Compoe compoeCollection1NewCompoe : compoeCollection1New) {
                if (!compoeCollection1Old.contains(compoeCollection1NewCompoe)) {
                    Produto oldProduto1OfCompoeCollection1NewCompoe = compoeCollection1NewCompoe.getProduto();
                    compoeCollection1NewCompoe.setProduto(produto);
                    compoeCollection1NewCompoe = em.merge(compoeCollection1NewCompoe);
                    if (oldProduto1OfCompoeCollection1NewCompoe != null && !oldProduto1OfCompoeCollection1NewCompoe.equals(produto)) {
                        oldProduto1OfCompoeCollection1NewCompoe.getCompoeCollection1().remove(compoeCollection1NewCompoe);
                        oldProduto1OfCompoeCollection1NewCompoe = em.merge(oldProduto1OfCompoeCollection1NewCompoe);
                    }
                }
            }
            em.getTransaction().commit();
        } catch (Exception ex) {
            String msg = ex.getLocalizedMessage();
            if (msg == null || msg.length() == 0) {
                Integer id = produto.getId();
                if (findProduto(id) == null) {
                    throw new NonexistentEntityException("The produto with id " + id + " no longer exists.");
                }
            }
            throw ex;
        } finally {
            if (em != null) {
                em.close();
            }
        }
    }

    public void destroy(Integer id) throws IllegalOrphanException, NonexistentEntityException {
        EntityManager em = null;
        try {
            em = getEntityManager();
            em.getTransaction().begin();
            Produto produto;
            try {
                produto = em.getReference(Produto.class, id);
                produto.getId();
            } catch (EntityNotFoundException enfe) {
                throw new NonexistentEntityException("The produto with id " + id + " no longer exists.", enfe);
            }
            List<String> illegalOrphanMessages = null;
            Collection<PedidoProducao> pedidoProducaoCollectionOrphanCheck = produto.getPedidoProducaoCollection();
            for (PedidoProducao pedidoProducaoCollectionOrphanCheckPedidoProducao : pedidoProducaoCollectionOrphanCheck) {
                if (illegalOrphanMessages == null) {
                    illegalOrphanMessages = new ArrayList<String>();
                }
                illegalOrphanMessages.add("This Produto (" + produto + ") cannot be destroyed since the PedidoProducao " + pedidoProducaoCollectionOrphanCheckPedidoProducao + " in its pedidoProducaoCollection field has a non-nullable produto field.");
            }
            Collection<Venda> vendaCollectionOrphanCheck = produto.getVendaCollection();
            for (Venda vendaCollectionOrphanCheckVenda : vendaCollectionOrphanCheck) {
                if (illegalOrphanMessages == null) {
                    illegalOrphanMessages = new ArrayList<String>();
                }
                illegalOrphanMessages.add("This Produto (" + produto + ") cannot be destroyed since the Venda " + vendaCollectionOrphanCheckVenda + " in its vendaCollection field has a non-nullable produto field.");
            }
            Collection<Fornece> forneceCollectionOrphanCheck = produto.getForneceCollection();
            for (Fornece forneceCollectionOrphanCheckFornece : forneceCollectionOrphanCheck) {
                if (illegalOrphanMessages == null) {
                    illegalOrphanMessages = new ArrayList<String>();
                }
                illegalOrphanMessages.add("This Produto (" + produto + ") cannot be destroyed since the Fornece " + forneceCollectionOrphanCheckFornece + " in its forneceCollection field has a non-nullable produto field.");
            }
            Collection<Compra> compraCollectionOrphanCheck = produto.getCompraCollection();
            for (Compra compraCollectionOrphanCheckCompra : compraCollectionOrphanCheck) {
                if (illegalOrphanMessages == null) {
                    illegalOrphanMessages = new ArrayList<String>();
                }
                illegalOrphanMessages.add("This Produto (" + produto + ") cannot be destroyed since the Compra " + compraCollectionOrphanCheckCompra + " in its compraCollection field has a non-nullable produto field.");
            }
            Collection<Compoe> compoeCollectionOrphanCheck = produto.getCompoeCollection();
            for (Compoe compoeCollectionOrphanCheckCompoe : compoeCollectionOrphanCheck) {
                if (illegalOrphanMessages == null) {
                    illegalOrphanMessages = new ArrayList<String>();
                }
                illegalOrphanMessages.add("This Produto (" + produto + ") cannot be destroyed since the Compoe " + compoeCollectionOrphanCheckCompoe + " in its compoeCollection field has a non-nullable produto field.");
            }
            Collection<Compoe> compoeCollection1OrphanCheck = produto.getCompoeCollection1();
            for (Compoe compoeCollection1OrphanCheckCompoe : compoeCollection1OrphanCheck) {
                if (illegalOrphanMessages == null) {
                    illegalOrphanMessages = new ArrayList<String>();
                }
                illegalOrphanMessages.add("This Produto (" + produto + ") cannot be destroyed since the Compoe " + compoeCollection1OrphanCheckCompoe + " in its compoeCollection1 field has a non-nullable produto1 field.");
            }
            if (illegalOrphanMessages != null) {
                throw new IllegalOrphanException(illegalOrphanMessages);
            }
            em.remove(produto);
            em.getTransaction().commit();
        } finally {
            if (em != null) {
                em.close();
            }
        }
    }

    public List<Produto> findProdutoEntities() {
        return findProdutoEntities(true, -1, -1);
    }

    public List<Produto> findProdutoEntities(int maxResults, int firstResult) {
        return findProdutoEntities(false, maxResults, firstResult);
    }

    private List<Produto> findProdutoEntities(boolean all, int maxResults, int firstResult) {
        EntityManager em = getEntityManager();
        try {
            Query q = em.createQuery("select object(o) from Produto as o");
            if (!all) {
                q.setMaxResults(maxResults);
                q.setFirstResult(firstResult);
            }
            return q.getResultList();
        } finally {
            em.close();
        }
    }

    public Produto findProduto(Integer id) {
        EntityManager em = getEntityManager();
        try {
            return em.find(Produto.class, id);
        } finally {
            em.close();
        }
    }

    public int getProdutoCount() {
        EntityManager em = getEntityManager();
        try {
            Query q = em.createQuery("select count(o) from Produto as o");
            return ((Long) q.getSingleResult()).intValue();
        } finally {
            em.close();
        }
    }

}
